<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */
// +----------------------------------------------------------------------+
// | PHP version 5                                                        |
// +----------------------------------------------------------------------+
// | Copyright 2005-2006 the Seasar Foundation and the Others.            |
// +----------------------------------------------------------------------+
// | Licensed under the Apache License, Version 2.0 (the "License");      |
// | you may not use this file except in compliance with the License.     |
// | You may obtain a copy of the License at                              |
// |                                                                      |
// |     http://www.apache.org/licenses/LICENSE-2.0                       |
// |                                                                      |
// | Unless required by applicable law or agreed to in writing, software  |
// | distributed under the License is distributed on an "AS IS" BASIS,    |
// | WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,                        |
// | either express or implied. See the License for the specific language |
// | governing permissions and limitations under the License.             |
// +----------------------------------------------------------------------+
// | Authors: klove                                                       |
// +----------------------------------------------------------------------+
//
// $Id: S2Container_InterceptorChain.class.php 238 2006-03-22 14:05:00Z klove $
/**
 * @package org.seasar.framework.aop.interceptors
 * @author klove
 */
class S2Container_InterceptorChain extends S2Container_AbstractInterceptor
{
    
    private $interceptors = array();

    /**
     * 
     */
    public function add(S2Container_MethodInterceptor $interceptor)
    {
        $this->interceptors[] = $interceptor;
    }

    /**
     * 
     */
    public function invoke(S2Container_MethodInvocation $invocation)
    {
        $nestInvocation = new S2Container_NestedMethodInvocation($invocation,
                $this->interceptors);
        return $nestInvocation->proceed();
    }
}
?>
